(* Copyright  2006 Jeremy English <jhe@jeremyenglish.org>
 *
 * Permission to use, copy, modify, distribute, and sell this software and its
 * documentation for any purpose is hereby granted without fee, provided that
 * the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation.  No representations are made about the suitability of this
 * software for any purpose.  It is provided "as is" without express or
 * implied warranty.
 *
 * Created: 16-January-2006
 *)
 
program quiet;

uses
  windows,
  dialogs,
  sysutils;

procedure run_program(cmd : ansistring);
var
  si : TStartupInfo;
  pi : TProcessINformation;
const
  ENDL = #$0d#$0a;
begin
  GetStartupInfo(si);
  si.dwFlags := STARTF_USESTDHANDLES or STARTF_USESHOWWINDOW;
  {key to quietness or shutup dos this is suppose to be windows}
  si.wShowWindow := SW_HIDE;

  if not createProcess(nil,PChar(cmd),nil,nil,True,
    0,nil, nil,si,pi) then
  begin
    messagedlg(format(
      'Could not create process %s. %s %s',
       [cmd,ENDL,SysErrorMessage(GetLastError)]),
        mtError, [mbOk], 0);
    exit;
  end;
end;

var
  i : integer;
  s : ansistring;
begin
  i := 1;
  s := '';
  while (i <= paramcount) do
  begin
    s := s + paramstr(i) + ' ';
    inc(i);
  end;
  run_program(s);
end.
